//region 配置区
// 展开所有折叠, 默认false, 折叠
unbox_all = false;
// 显示音节划分, 默认true,显示,点击会自动切换
show_syllable = true;
// 隐藏翻译, 默认true 显示
show_translation = true;
// 简化词性, 默认false
simplify_pos = false;
// 简化语法, 默认false
simplify_grammar = false;
// 显示多词义导航(仅有多词义显示)
show_nav = true;
// 多词义导航 是否默认显示All
nav_default_all = true;
// 在线发音 (默认离线) 启用后,可以删除 1.mdd
online_pron = false;
// 在线图片 (默认离线) 启用后,可以删除 2.mdd
online_image = false;
// 在线例句发音 (默认在线) 禁用后,需要下载 3.mdd (仅捐赠用户)
online_example_pron = true;

// 鼠标滑过选中
enable_nav_control_hover = true;
// 鼠标滑过发音
enable_hover_pron = true;

// 英语释义支持点击折叠,默认开启
enable_collapse = true;
// Idioms / phrasal verb支持折叠展开
hideIdioms = false;
hidePhrasalVerb = false;

// 释义例句简化 something/somebody 缩写
sb_sth_abbr = true;
// 加入中文 和 例句显示按钮
oald_control = true;
// 简明按钮, 需启用 oald_control
oald_concise = false

// 捐赠用户定制需求
// added for laoyu
oald_click_dispaly_CN = false
oald_hover_dispaly_CN = false
// 默认展开origin, added for weshor
oald_expand_origin = false


// 例句,释义,在线tts发音,需要高版本浏览器内核. Mdict不支持
enable_online_tts = true;
// 英音发音配置  英音男1 - 英音男2  ; 英音女1 - 英音女3
gb_tts = "英音男1";
// 美音发音配置  美音男1 - 美音男5 ;  美音女1 - 美音女4
us_tts = "美音女1";
//endregion

//region debug
oald_debug = false
if (oald_debug) {
    online_pron = true
    online_example_pron = true
}
// mdict 不兼容功能移除
if (navigator.userAgent.toLowerCase().indexOf(".net4.0") > -1) {
    enable_online_tts = false
    online_pron = false
    online_example_pron = false
}
//endregion

is_oald_loaded = 'undefined' != typeof (is_oald_loaded)
console.log("~~~~~~~is_oald_loaded ", is_oald_loaded)

//region 常量
oald_root_class = "leon-oald"
oald_root_selector = "." + oald_root_class
oald_nav_class = "nav-oald"
oald_nav_selector = "." + oald_nav_class
oald_control_class = "control"
oald_control_selector = "." + oald_control_class

var ttsGlobalAudio = new Audio();
var globalAudio = new Audio();
var prefix_uk = "https://www.oxfordlearnersdictionaries.com/media/english/uk_pron/";
var prefix_us = "https://www.oxfordlearnersdictionaries.com/media/english/us_pron/";
var prefix_EXAMPLE = "https://oxford-x-file.oss-cn-hangzhou.aliyuncs.com/audio/xgs/xgs_audio/";
var prefix_full_image = "https://www.oxfordlearnersdictionaries.com/us/media/english/fullsize/";
var prefix_thumb_image = "https://www.oxfordlearnersdictionaries.com/us/media/english/thumb/";
//endregion

//region DOM加载初始化
!is_oald_loaded && document.addEventListener('DOMContentLoaded', function () {

    leon_oald.interaction()
    leon_oald.simplify()
    show_nav && leon_oald.addNavigation();

    leon_oald.onlineAudioAndImage()

    hideIdioms && leon_oald.elementsHide(".idioms>span:not(:first-child)");
    hidePhrasalVerb && leon_oald.elementsHide(".phrasal_verb_links>.pvrefs");

    oald_control && leon_oald.addControl()
    oald_debug && vConsole();
    enable_online_tts && leon_oald.addOnlineTts()

    leon_oald.hoverPron()
    leon_oald.addMeanClickDisplay()
    leon_oald.compatible()
});
//endregion

//region 全局唯一对象,进行方法隔离
leon_oald = {
    root: function () {
        let oald = document.querySelector(oald_root_selector);
        if (!oald) return document;
        return oald.parentElement ? oald.parentElement : oald;
    },

    interaction: function () {
        this.elementsFn("#ox-enlarge", function (element) {
            element.addEventListener("click", function () {
                leon_oald.toggle_enlarger(element);
            })
        });
        this.elementsFn(".box_title", function (element) {
            element.addEventListener("click", function () {
                leon_oald.toggle_active(element);
            })
            if (unbox_all)
                leon_oald.toggle_active(element)
        });
        this.elementsFn(".headword", function (element) {
            element.addEventListener("click", function () {
                leon_oald.toggle_syllable(element);
            })
            if (!show_syllable)
                leon_oald.toggle_syllable(element)
        });
        this.elementsFn("chn", function (element) {
            if (!show_translation)
                element.style.display = 'none';
        });

        this.elementsClick(".idioms>span:first-child,.phrasal_verb_links>span:first-child,.shcut", function (ele) {
            if (!ele.nextElementSibling)
                return;
            var state = ele.nextElementSibling.style.display;
            console.log("state tg", state, !state)
            if (state === "none") {
                nodeDisplay(ele, "block")
            } else {
                nodeDisplay(ele, "none")
            }
        });

        enable_collapse && this.elementsClick(".sense>span:first-child", function (ele) {
            if (!ele.nextElementSibling)
                return;
            var state = ele.nextElementSibling.style.display;
            if (state === "none") {
                nodeDisplay(ele, "block", false, false, function (ele) {
                    return ele.className !== "examples"
                })
            } else {
                nodeDisplay(ele, "none", false, false, function (ele) {
                    return ele.className !== "examples"
                })
            }
        });
        var excludeTagName = ["DEFT", "CHN"]
        // 释义 def
        enable_collapse && this.elementsClick(".def", function (ele) {
            if (!ele.nextElementSibling)
                return;

            let next = ele.nextElementSibling;
            while (next && excludeTagName.indexOf(next.tagName) > -1) {
                next = next.nextElementSibling
            }
            var state = next && next.style && next.style.display;

            if (state === "none") {
                nodeDisplay(ele, "block", true, false, function (ele) {
                    return excludeTagName.indexOf(ele.tagName) > -1
                })
            } else {
                nodeDisplay(ele, "none", true, false, function (ele) {
                    return excludeTagName.indexOf(ele.tagName) > -1
                })
            }
        })
        oald_expand_origin && this.elementsFn("[unbox='wordorigin']", function (ele) {
            leon_oald.toggle_active(ele.children[0]);
        })
    },
    simplify: function () {
        simplify_pos && this.elementsFn(".pos", function (element) {
            element.setAttribute("title", element.textContent.replace("[", "").replace("]", ""))
            element.textContent = POS[element.textContent];
        });
        simplify_grammar && this.elementsFn(".grammar", function (element) {
            element.setAttribute("title", element.textContent.replace("[", "").replace("]", ""))
            element.textContent = GRAMMAR[element.textContent];
        });
        sb_sth_abbr && this.elementsFn(".x,.def,.cf", function (element) {
            element.innerHTML = element.innerHTML
                .replace(/\bsomething\b/g, "sth")
                .replace(/\bsomebody\b/g, "sb")
            ;
        });
    },

    onlineAudioAndImage: function () {
        online_pron && this.elementsFn(".audio_play_button:not(.app)", function (element) {
            element.href = leon_oald.get_online_pron_url(element.href);
            element.onclick = function (e) {
                e.preventDefault();
                globalAudio.pause()
                globalAudio.src = element.href;
                globalAudio.play();
            }
        });

        online_example_pron && this.elementsFn(".audio_play_button.app", function (element) {
            element.href = leon_oald.get_online_example_pron_url(element.href);
        });

        online_image && this.elementsFn(".fullsize, .thumb", function (element) {
            console.log(element);
            element.src = leon_oald.get_online_image_url(element.src);
            console.log(element);
        });
    },
    toggle_enlarger: function (ctl) {
        var fullsize = ctl.children[0].children[0],
            thumb = ctl.children[0].children[1];
        if (!fullsize.style.display || fullsize.style.display === 'none') {
            thumb.style.display = 'none';
            fullsize.style.display = 'block';
        } else {
            fullsize.style.display = 'none';
            thumb.style.display = 'block';
        }
    },
    toggle_active: function (ctl) {
        ctl.parentElement.classList.toggle('is-active');
        var examples = ctl.parentElement.querySelector('[unbox="extra_examples"] .examples');
        if (examples) {
            var isActive = ctl.parentElement.classList.contains('is-active');
            if (isActive) {
                showEle(examples);
            } else {
                hideEle(examples);
            }
        }
    },
    toggle_syllable: function (ctl) {
        if (ctl.hasAttribute("syllable")) {
            ctl.textContent = ctl.textContent.indexOf("·") > -1 ? ctl.textContent.replace(/·/g, "") : ctl.getAttribute("syllable");
        }
    },
    get_online_example_pron_url: function (src) {
        var parts = src.split('/');
        var name = parts[parts.length - 1];
        return prefix_EXAMPLE + name.replace("#", "%23").replace(".mp3", ".wav");
    },
    get_online_pron_url: function (src) {
        var parts = src.split('/');
        var name = parts[parts.length - 1];
        return (name.indexOf("_gb_") > -1 ? prefix_uk : prefix_us) + name.substring(0, 1) + '/' + name.substring(0, 3) + '/' + name.substring(0, 5) + '/' + name;
    },
    get_online_image_url: function (src) {
        var parts = src.split('/');
        parts = parts[parts.length - 1].split('_');
        var name = parts[1];
        console.log(parts)
        return (parts[0] === "fullsize" ? prefix_full_image : prefix_thumb_image) + name.substring(0, 1) + '/' + name.substring(0, 3) + '/' + name.substring(0, 5) + '/' + name;
    },
    addNavigation: function () {
        let root = leon_oald.root();
        // 已添加不添加
        console.log("__", root, root.querySelector(oald_nav_selector))
        if (root.querySelector(oald_nav_selector))
            return;

        let eles = root.querySelectorAll(".oald");
        console.log("addNavigation", eles.length);
        // 只有一个entry不添加
        if (eles.length < 2)
            return;
        let container = document.createElement('div');
        container.setAttribute("class", oald_nav_class);
        for (let i = 0; i < eles.length; i++) {
            let sp = document.createElement('span');
            let pos = eles[i].querySelector(".pos");
            pos = pos && pos.textContent;
            pos = !pos ? eles[i].querySelector(".headword").textContent : pos;
            sp.textContent = POS[pos] ? POS[pos] : pos.replaceAll("·", "");
            if (i === 0) {
                sp.classList.add('active');
            }
            let listener = function () {
                let index = leon_oald.navIndex(this);
                console.log(index);
                for (let j = 0; j < container.children.length; j++) {
                    container.children[j].classList.remove('active');
                }
                this.classList.add('active');
                leon_oald.showHideEntry(index)
            };
            sp.addEventListener("click", listener)
            enable_nav_control_hover && sp.addEventListener("mouseover", listener)
            container.appendChild(sp);
        }

        // 新增All
        let sp = document.createElement('span');
        sp.textContent = "All";
        container.appendChild(sp)
        let listener1 = function () {
            for (let j = 0; j < container.children.length; j++) {
                container.children[j].classList.remove('active');
            }
            this.classList.add('active');
            leon_oald.showHideEntry(-1)
        };
        sp.addEventListener("click", listener1)
        enable_nav_control_hover && sp.addEventListener("mouseover", listener1)
        leon_oald.showHideEntry(0);
        if (nav_default_all) {
            sp.click();
        }
        root.insertBefore(container, root.childNodes[0]);
    },
    addControl: function () {
        let root = leon_oald.root();
        // 已添加不添加
        console.log("__ hasControl", root.querySelector(oald_control_selector))
        if (root.querySelector(oald_control_selector))
            return;
        let moreSelectors = ".collapse[hClass],.shcut,.topic-g,.xrefs,.idioms,phrasal_verb_links," +
            ".phrasal_verb_links,.use,.jumplinks,.un";
        let zhs = leon_oald.queryThisSelector("chn")
        let example = leon_oald.queryThisSelector(".examples")
        let more = leon_oald.queryThisSelector(moreSelectors)
        console.log(zhs, !zhs, example)

        if (!zhs && !example && (!oald_concise || !more)) {
            return;
        }
        this.elementsFn(".headword ~.pos,.leon-oald.idm-g .idm,.headword", function (ele) {
            if (ele.className === "headword" && ele.nextElementSibling.className === "pos") {
                return
            }

            let container = document.createElement('span');
            container.setAttribute("class", oald_control_class);
            // 存在chn才显示
            if (zhs) {
                let chn = document.createElement('span');
                chn.textContent = "中文"
                chn.classList.add("chn-control")
                if (!show_translation) {
                    chn.classList.add('collapse');
                }
                let chnListener = function () {
                    leon_oald.elementsFn(".chn-control", function (ele) {
                        ele.classList.toggle('collapse');
                    })
                    leon_oald.elementsDisplay("chn", this.classList.contains('collapse') ? "none" : "inline")
                };
                chn.addEventListener("click", chnListener)
                enable_nav_control_hover && chn.addEventListener("mouseover", chnListener)
                container.appendChild(chn);
            }
            // 存在examples才显示
            if (example) {
                let examplesEle = document.createElement('span');
                examplesEle.textContent = "例句"
                examplesEle.classList.add("examples-control")
                let exampleListener = function () {
                    leon_oald.elementsFn(".examples-control", function (ele) {
                        ele.classList.toggle('collapse');
                    })
                    leon_oald.elementsFn(".examples", function (ele) {
                        if (!ele.parentNode.classList.contains("unbox")) {
                            ele.style.display = examplesEle.classList.contains('collapse') ? "none" : "block"
                        }
                    })
                };
                examplesEle.addEventListener("click", exampleListener)
                enable_nav_control_hover && examplesEle.addEventListener("mouseover", exampleListener)
                container.appendChild(examplesEle);
            }
            if (oald_concise && more) {
                let moreEle = document.createElement('span');
                moreEle.textContent = "简明"
                moreEle.classList.add("more-control")
                let moreListener = function () {
                    leon_oald.elementsFn(".more-control", function (ele) {
                        ele.classList.toggle('collapse');
                        if (ele.classList.contains("collapse")) {
                            leon_oald.elementsHide(moreSelectors)
                        } else {
                            leon_oald.elementsShow(moreSelectors)
                        }
                    })
                };
                moreEle.addEventListener("click", moreListener)
                enable_nav_control_hover && moreEle.addEventListener("mouseover", moreListener)
                container.appendChild(moreEle);
            }
            if (ele.classList.contains("idm")) {
                ele.appendChild(container)
            } else {
                ele.insertAdjacentElement("afterend", container)
            }
        })
    },
    navIndex: function (ele) {
        var eles = document.querySelectorAll(oald_nav_selector + " span");
        for (var i = 0; i < eles.length; i++) {
            if (eles[i] === ele)
                return i;
        }
    },
    showHideEntry: function (index) {
        var eles = document.querySelectorAll(oald_root_selector);
        for (var i = 0; i < eles.length; i++) {
            if (index === i || index < 0)
                showEle(eles[i]);
            else
                hideEle(eles[i]);
        }
    },
    addMeanClickDisplay: function () {
        // click hide show chinese
        let selector = ".x,.def,.unx";
        oald_click_dispaly_CN && leon_oald.elementsClick(selector, function (ele, event) {
            event.stopImmediatePropagation()
            let zh = ele.querySelector("chn")
            zh = zh ? zh : ele.parentNode.querySelector("chn");
            if (zh) {
                zh.style.display = zh.style.display == "none" || zh.style.display == "" ? "inline" : "none";
            }
        })
        oald_hover_dispaly_CN && leon_oald.elementsEvent(selector, "mouseover", function (ele, event) {
            let zh = ele.querySelector("chn")
            zh = zh ? zh : ele.parentNode.querySelector("chn");
            if (zh) {
                zh.style.display = zh.style.display == "none" || zh.style.display == "" ? "inline" : "none";
            }
        })
    },
    addOnlineTts: function () {
        // 在线tts
        this.elementsFn(".x,.unx", function (element) {
            oald_debug && console.log("______addOnlineTts", element)
            if (!element.parentNode.querySelector(".pron-uk")) {
                let pron_uk = document.createElement('span');
                pron_uk.setAttribute("class", "sound audio_play_button pron-uk icon-audio");
                pron_uk.onclick = function () {
                    selectedTts = gb_tts;
                    var cp = element.cloneNode(true);
                    cp.querySelector("chn") && cp.querySelector("chn").remove()
                    speak(cp.textContent.replace(/\(.*?\)/g, ""));
                }
                element.parentNode.insertBefore(pron_uk, element);
            }
            if (!element.parentNode.querySelector(".pron-us")) {
                let pron_us = document.createElement('span');
                pron_us.setAttribute("class", "sound audio_play_button pron-us icon-audio");
                pron_us.onclick = function () {
                    selectedTts = us_tts;
                    var cp = element.cloneNode(true);
                    cp.querySelector("chn") && cp.querySelector("chn").remove()
                    speak(cp.textContent.replace(/\(.*?\)/g, ""));
                }
                element.parentNode.insertBefore(pron_us, element);
            }
        });
    },
    hoverPron: function () {
        enable_hover_pron && this.elementsFn(".icon-audio", function (ele) {
            ele.addEventListener("mouseover", function (e) {
                console.log("-----mouseover")
                if (ele.tagName.toLowerCase() == "a") {
                    e.preventDefault()
                    globalAudio.pause()
                    globalAudio.src = ele.href;
                    globalAudio.play();
                } else {
                    this.click()
                }
            })
        })
    },
    compatible: function () {
        console.log("---------- ccc", this.isPC(), !this.isDictApp())
        if (!this.isGoldenDict()) {
            this.elementsEvent("a", "click", function (ele, event) {
                console.log("----------", ele.href)
                if (ele.href.startsWith("http") && (ele.href.endsWith(".mp3")
                    || ele.href.endsWith(".wav")
                    || ele.href.endsWith(".ogg"))) {
                    console.log("---------- eeee")
                    event.preventDefault()
                    globalAudio.pause()
                    globalAudio.src = ele.href;
                    globalAudio.play();
                }
            })
        }
    },
    //region 通用功能
    thisSelector: function (selector) {
        return selector.split(",").map(function (s) {
                return s.indexOf(oald_root_selector) > -1 ? s : (oald_root_selector + " " + s)
            }
        )
            .join(",")
    },
    queryThisSelector: function (selector) {
        return document.querySelector(oald_root_selector + " " + selector.split(",").join("," + oald_root_selector + " "))
    },
    queryThisSelectorAll: function (selector) {
        return document.querySelectorAll(oald_root_selector + " " + selector.split(",").join("," + oald_root_selector + " "))
    },
    // common
    elementsFn: function (selector, fn) {
        selector = this.thisSelector(selector)
        var eles = document.querySelectorAll(selector);
        for (var i = 0; i < eles.length; i++) {
            fn(eles[i]);
        }
    },

    elementsClick: function (selector, fn) {
        this.elementsEvent(selector, "click", fn)
    },
    elementsEvent: function (selector, eventName, fn) {
        var events = eventName.split(",")
        for (let i = 0; i < events.length; i++) {
            this.elementsFn(selector, function (ele) {
                ele.addEventListener(events[i], function (event) {
                    fn(ele, event);
                })
            })
        }
    },
    elementEvent: function (ele, eventName, fn) {
        var events = eventName.split(",")
        for (let i = 0; i < events.length; i++) {
            ele.addEventListener(events[i], function (event) {
                fn(event, ele);
            })
        }
    },
    elementsDisplay: function elementsDisplay(selector, value) {
        this.elementsFn(selector, function (ele) {
            ele.style.display = value;
        })
    },

    elementsHide: function (selector) {
        this.elementsDisplay(selector, "none")
    },

    elementsShow: function elementsShow(selector) {
        this.elementsDisplay(selector, "block")
    },
    //endregion

    //region 调试兼容
    isDebug: function () {
        return this.isPC() && !this.isDictApp()
    },
    isPC: function () {
        const ua = navigator.userAgent
        return ua.indexOf("Edge") > -1
            || ua.indexOf("Chrome") > -1
            || ua.indexOf("Firefox") > -1
            || ua.indexOf("Safari") > -1
    },
    isDictApp: function () {
        const ua = navigator.userAgent.toLowerCase()
        return ua.indexOf("goldendict") > -1
            || ua.indexOf("eudic") > -1
            // MDICT
            || ua.indexOf(".net4.0") > -1
            || ua.indexOf("iphone") > -1
            || ua.indexOf("android") > -1
            || ua.indexOf("ipad") > -1
    },
    isMDict: function () {
        return navigator.userAgent.toLowerCase().indexOf(".net4.0") > -1
    },
    isGoldenDict: function () {
        return navigator.userAgent.toLowerCase().indexOf(".goldendict") > -1
    },
    isEudic: function () {
        return navigator.userAgent.toLowerCase().indexOf("eudic") > -1
    },
    //endregion
}
//endregion

/* 精简 */
//region 词性替换表
var POS = {
    "noun": "n.",
    "adjective": "adj.",
    "adverb": "adv.",
    "abbreviation": "abbr.",
    "adverb, adjective": "adv., adj.",
    "verb": "v.",
    "phrasal verb": "phrasal v.",
    "exclamation": "interj.",
    "idiom": "idiom",
    "conjunction": "conj.",
    "preposition": "prep.",
    "modal verb": "modal v.",
    "combining form": "combining form",
    "prefix": "prefix",
    "linking verb": "linking v.",
    "suffix": "suffix",
    "number": "num.",
    "pronoun": "pron.",
    "ordinal number": "ordinal num.",
    "determiner": "det.",
    "auxiliary verb": "aux. v.",
    "indefinite article": "indefinite a.",
    "definite article": "definite a.",
    "infinitive marker": "infinitive marker",
    "symbol": "symbol",
    "adjective, adverb": "adj., adv.",
    "adverb, preposition": "adv., prep.",
    "noun, adjective": "n., adj.",
    "short form": "short form",
    "noun, exclamation": "n., interj.",
    "exclamation, noun": "interj., n.",
    "determiner, pronoun": "det., pron.",
    "preposition, adverb": "prep., adv.",
    "adjective, exclamation": "adj., interj.",
    "preposition, conjunction, adverb": "prep., conj., adv.",
    "adjective, adverb, exclamation": "adj., adv., interj.",
    "adjective, noun": "adj., n.",
    "adverb, exclamation": "adv., interj.",
    "noun, determiner": "n., det.",
    "determiner, pronoun, adverb": "det., pron., adv.",
    "conjunction, preposition": "conj., prep.",
    "adverb, pronoun, conjunction": "adv., pron., conj.",
    "determiner, adjective": "det., adj.",
    "determiner, ordinal number": "det., ordinal num.",
    "noun, abbreviation": "n., abbr.",
    "exclamation, adjective": "interj., adj.",
    "conjunction, adverb": "conj., adv.",
    "adjective, pronoun": "adj., pron.",
    "number, determiner": "num., det.",
    "noun, verb": "n., v.",
    "pronoun, determiner": "pron., det.",
    "preposition, conjunction": "prep., conj.",
    "exclamation, adverb, pronoun": "interj., adv., pron.",
    "adverb, conjunction": "adv., conj.",
    "adverb, noun": "adv., n.",
}
//endregion

//region 语法替换表
var GRAMMAR = {
    "[uncountable]": "[U]",
    "[only before noun]": "[only bf N]",
    "[singular]": "[sing]",
    "[countable]": "[C]",
    "[countable, uncountable]": "[C, U]",
    "[after noun]": "[aft N]",
    "[not before noun]": "[not bf N]",
    "[usually before noun]": "[usu bf N]",
    "[usually singular]": "[usu sing]",
    "[uncountable, countable]": "[U, C]",
    "[intransitive, transitive]": "[I, T]",
    "[usually passive]": "[usu psv]",
    "[plural]": "[pl]",
    "[transitive]": "[T]",
    "[uncountable, singular]": "[U, sing]",
    "[intransitive]": "[I]",
    "[often passive]": "[oft psv]",
    "[not usually before noun]": "[not usu bf N]",
    "[singular, uncountable]": "[sing, U]",
    "[uncountable, plural]": "[U, pl]",
    "[usually plural]": "[usu pl]",
    "[countable, usually plural]": "[C, usu pl]",
    "[uncountable, countable, usually singular]": "[U, C, usu sing]",
    "[transitive, intransitive]": "[T, I]",
    "[intransitive, transitive, often passive]": "[I, T, oft psv]",
    "[transitive, often passive]": "[T, oft psv]",
    "[countable, usually singular]": "[C, usu sing]",
    "[countable + singular or plural verb]": "[C + sing or pl V]",
    "[uncountable + singular or plural verb]": "[U + sing or pl V]",
    "[transitive, usually passive]": "[T, usu psv]",
    "[transitive, often passive, intransitive]": "[T, oft psv, I]",
    "[no passive]": "[no psv]",
    "[countable, usually singular, uncountable]": "[C, usu sing, U]",
    "[countable, usually plural, uncountable]": "[C, usu pl, U]",
    "[plural, singular or plural verb]": "[pl, sing or pl V]",
    "[singular + singular or plural verb]": "[sing + sing or pl V]",
    "[countable, singular, uncountable]": "[C, sing, U]",
    "[intransitive, transitive, no passive]": "[I, T, no psv]",
    "[transitive, no passive]": "[T, no psv]",
    "[uncountable, countable, usually plural]": "[U, C, usu pl]",
    "[plural, uncountable]": "[pl, U]",
    "[countable + singular or plural verb, uncountable]": "[C + sing or pl V, U]",
    "[transitive, intransitive, often passive]": "[T, I, oft psv]",
    "[intransitive, transitive, usually passive]": "[I, T, usu psv]",
    "[transitive, usually passive, intransitive]": "[T, usu psv, I]",
    "[countable, plural]": "[C, pl]",
    "[singular or plural verb]": "[sing or pl V]",
    "[countable, uncountable + singular or plural verb]": "[C, U + sing or pl V]",
    "[uncountable + singular or plural verb, countable]": "[U + sing or pl V, C]",
    "[countable, singular]": "[C, sing]",
    "[uncountable, countable, singular]": "[U, C, sing]",
    "[countable, singular + singular or plural verb]": "[C, sing + sing or pl V]",
    "[singular + singular or plural verb, uncountable]": "[sing + sing or pl V, U]",
    "[transitive, no passive, intransitive]": "[T, no psv, I]",
    "[usually singular, uncountable]": "[usu sing, U]",
    "[transitive, intransitive, usually passive]": "[T, I, usu psv]",
}
//endregion

//region 通用方法
function hideEle(ele) {
    ele.style.display = 'none';
}

function showEle(ele) {
    ele.style.display = 'block';
}

function nodeDisplay(node, value, fromThis, includeThis, excludeFunc, inlineList) {
    var nodes = node.parentElement.childNodes;
    var isFindThis = false
    for (var i = 0; i < nodes.length; i++) {
        let currentNode = nodes[i];
        if (excludeFunc && excludeFunc(currentNode)) {
            continue;
        }
        if (fromThis) {
            if (node === currentNode) {
                isFindThis = true;
            }
            if (!isFindThis)
                continue;
        }
        if (!includeThis && node === currentNode)
            continue;

        if (currentNode.style) {
            var display = "block"
            if (inlineList && inlineList.indexOf(currentNode.className) > -1) {
                display = "inline"
            }
            currentNode.style.display = value === "block" ? display : value;
        }
    }
}

function addScript(src, func) {
    let script = document.createElement('script');
    script.type = 'text/javascript';
    document.body.appendChild(script);
    if (src) {
        script.src = src;
    }
    script.onload = func;
}

function vConsole() {
    if ('undefined' == typeof (VConsole)) {
        addScript("https://cdn.bootcss.com/vConsole/3.15.0/vconsole.min.js", function () {
            var vConsole = new VConsole();
        })
    }
}

//endregion

//region tts 功能
var ttsConfig = {
    "美音女1": {
        locale: "en-US",
        voice: "en-US-MichelleNeural",
        pitch: "+0Hz",
        rate: "+0%",
        volume: "+0%",
    },
    "美音女2": {
        locale: "en-US",
        voice: "en-US-AriaNeural",
        pitch: "+0Hz",
        rate: "+20%",
        volume: "+0%",
    },
    "美音女3": {
        locale: "en-US",
        voice: "en-US-AnaNeural",
        pitch: "+0Hz",
        rate: "+20%",
        volume: "+0%",
    },
    "美音女4": {
        locale: "en-US",
        voice: "en-US-JennyNeural",
        pitch: "+0Hz",
        rate: "+0%",
        volume: "+0%",
    },
    "美音男1": {
        locale: "en-US",
        voice: "en-US-ChristopherNeural",
        pitch: "+0Hz",
        rate: "+0%",
        volume: "+0%",
    },
    "美音男2": {
        locale: "en-US",
        voice: "en-US-EricNeural",
        pitch: "+0Hz",
        rate: "+0%",
        volume: "+0%",
    },
    "美音男3": {
        locale: "en-US",
        voice: "en-US-GuyNeural",
        pitch: "+0Hz",
        rate: "+0%",
        volume: "+0%",
    },
    "美音男4": {
        locale: "en-US",
        voice: "en-US-RogerNeural",
        pitch: "+0Hz",
        rate: "+0%",
        volume: "+0%",
    },
    "美音男5": {
        locale: "en-US",
        voice: "en-US-SteffanNeural",
        pitch: "+0Hz",
        rate: "+0%",
        volume: "+0%",
    },
    "英音女1": {
        locale: "en-GB",
        voice: "en-GB-SoniaNeural",
        pitch: "+0Hz",
        rate: "+0%",
        volume: "+0%",
    },
    "英音女2": {
        locale: "en-GB",
        voice: "en-GB-MaisieNeural",
        pitch: "+0Hz",
        rate: "+0%",
        volume: "+0%",
    },
    "英音女3": {
        locale: "en-GB",
        voice: "en-GB-LibbyNeural",
        pitch: "+0Hz",
        rate: "+0%",
        volume: "+0%",
    },
    "英音男1": {
        locale: "en-GB",
        voice: "en-GB-RyanNeural",
        pitch: "+0Hz",
        rate: "+0%",
        volume: "+0%",
    },
    "英音男2": {
        locale: "en-GB",
        voice: "en-GB-ThomasNeural",
        pitch: "+0Hz",
        rate: "+0%",
        volume: "+0%",
    },
}

var selectedTts = "美音女1";

function create_edge_TTS(
    timeout = 10,
    auto_reconnect = true) {

    const TRUSTED_CLIENT_TOKEN = "6A5AA1D4EAFF4E9FB37E23D68491D6F4";
    const VOICES_URL = `https://speech.platform.bing.com/consumer/speech/synthesize/readaloud/voices/list?trustedclienttoken=${TRUSTED_CLIENT_TOKEN}`;
    const SYNTH_URL = `wss://speech.platform.bing.com/consumer/speech/synthesize/readaloud/edge/v1?TrustedClientToken=${TRUSTED_CLIENT_TOKEN}`;
    const BINARY_DELIM = "Path:audio\r\n";
    const VOICE_LANG_REGEX = /\w{2}-\w{2}/;

    let _outputFormat = "audio-24khz-48kbitrate-mono-mp3";
    /* 修改发音人和语言 */
    let _voiceLocale = 'en-US',
        _voice = 'en-US-MichelleNeural',
        // 调整音色
        _pitch = '+0Hz',
        // 调整速度
        _rate = '+20%',
        // 调整音量
        _volume = '+0%';

    const _queue = {
        message: [],
        url_resolve: {},
        url_reject: {},
    };

    let ready = false;

    function _SSMLTemplate(input) {
        return `<speak version="1.0" xmlns="http://www.w3.org/2001/10/synthesis" xmlns:mstts="https://www.w3.org/2001/mstts" xml:lang="${ttsConfig[selectedTts].voiceLocale}">
                  <voice name="${ttsConfig[selectedTts].voice}">
				   <prosody pitch="${ttsConfig[selectedTts].pitch}" rate="${ttsConfig[selectedTts].rate}" volume="${ttsConfig[selectedTts].volume}">${input}</prosody>
                  </voice>
              </speak>`;
    }

    function uuidv4() {
        return ([1e7] + -1e3 + -4e3 + -8e3 + -1e11).replace(/[018]/g, c =>
            (c ^ crypto.getRandomValues(new Uint8Array(1))[0] & 15 >> c / 4).toString(16));
    }

    let socket = null;
    create_new_ws();

    function setFormat(format) {
        if (format)
            _outputFormat = format;

        /**/
        socket.send(`Content-Type:application/json; charset=utf-8\r\nPath:speech.config\r\n\r\n
                      {
                          "context": {
                              "synthesis": {
                                  "audio": {
                                      "metadataoptions": {
                                          "sentenceBoundaryEnabled": "false",
                                          "wordBoundaryEnabled": "false"
                                      },
                                      "outputFormat": "${_outputFormat}" 
                                  }
                              }
                          }
                      }
                  `);
    }

    async function createURL(requestId) {
        let index_message = 0;
        for (let message of _queue.message) {
            const isbinary = message instanceof Blob;

            if (!isbinary)
                continue;

            const data = await message.text();

            //console.log(data); //does the message order change?
            //console.log(await event.data.arrayBuffer());

            const Id = /X-RequestId:(.*?)\r\n/gm.exec(data)[1];

            if (Id !== requestId)
                continue;

            if (data.charCodeAt(0) === 0x00 && data.charCodeAt(1) === 0x67 && data.charCodeAt(2) === 0x58) {
                // Last (empty) audio fragment
                console.log(`Last (empty) audio fragment`)

                const blob = new Blob(_queue[requestId], {
                    'type': 'audio/mp3'
                });

                _queue[requestId] = null; //release memory

                const url = URL.createObjectURL(blob);
                console.log(url)

                //URL.revokeObjectURL(url);
                _queue.url_resolve[requestId](url);

                //return url

            } else {
                const index = data.indexOf(BINARY_DELIM) + BINARY_DELIM.length;

                const audioData = message.slice(index);
                _queue[requestId].push(audioData);

                _queue.message[index_message] = null; //release blob memory
            }

            ++index_message;
        }
    }

    function onopen(event) {
        console.log('open');
        //socket.send('Hello Server!');
        //socket.close()

        setFormat();
        ready = true;
    }

    async function onmessage(event) {
        const isbinary = event.data instanceof Blob;
        console.log(`Message from server, type: ${typeof (event.data)} Blob: ${isbinary}`);

        _queue.message.push(event.data)

        if (!isbinary) {
            //console.log(event.data);
            const requestId = /X-RequestId:(.*?)\r\n/gm.exec(event.data)[1];

            if (event.data.includes("Path:turn.end")) {
                // end of turn
                createURL(requestId);
            }

        } else {
        }
    }

    function onerror(event) {
        ready = false;
        console.log('WebSocket error: ', event);
    }

    function onclose(event) {
        ready = false;
        console.log('WebSocket close: ', event); //may be closed by remote
    }

    function addSocketListeners() {
        socket.addEventListener('open', onopen);
        // Listen for messages
        socket.addEventListener('message', onmessage);

        // Listen for possible errors
        socket.addEventListener('error', onerror);

        // Listen for possible errors
        socket.addEventListener('close', onclose);
    }

    function create_new_ws() {
        //try {
        // Create WebSocket connection.
        socket = new WebSocket(SYNTH_URL);
        addSocketListeners();
    }

    let toStream = function (input) {
        let requestSSML = _SSMLTemplate(input);
        const requestId = uuidv4().replaceAll('-', '');
        const request = `X-RequestId:${requestId}\r\nContent-Type:application/ssml+xml\r\nPath:ssml\r\n\r\n
                  ` + requestSSML.trim();

        _queue[requestId] = [];

        return new Promise((resolve, reject) => {
            _queue.url_resolve[requestId] = resolve,
                _queue.url_reject[requestId] = reject;

            if (!ready) {
                if (auto_reconnect) {
                    create_new_ws();
                    socket.addEventListener('open', _ => socket.send(request));

                    setTimeout(_ => {
                        if (!ready)
                            reject('reconnect timeout')
                    }, timeout * 1000);
                } else
                    reject('socket error or timeout');
            } else {
                socket.send(request)
            }

        });

    }

    async function play(input, play_count = 1, play_span = 5000) {
        const url = await toStream(input);

        let play_resolve = function () {
        };
        ttsGlobalAudio.pause();
        ttsGlobalAudio.src = url;
        // var audio = new Audio(url);
        console.log('before play' + ttsGlobalAudio.duration) //NaN
        //let play_count = 3; //repeat times
        ttsGlobalAudio.onended = (e) => {
            console.log(e);
            if (--play_count > 0) {
                console.log("play----");
                setTimeout(_ => ttsGlobalAudio.play(), play_span);
            } else {
                //URL.revokeObjectURL(url);
                play_resolve(url);
                console.log('play end');
            }
        }

        await ttsGlobalAudio.play();
        console.log('after play' + ttsGlobalAudio.duration);

        return new Promise((resolve, reject) => {
            play_resolve = resolve
        });

    }

    return new Promise((resolve, reject) => {
        setTimeout(_ => reject('socket open timeout'), timeout * 1000);
        // Connection opened
        socket.addEventListener('open', function (event) {

            resolve({
                _: play,
                toStream,
                setVoice: (voice, locale) => {
                    _voice = voice;
                    if (!locale) {
                        const voiceLangMatch = VOICE_LANG_REGEX.exec(_voice);
                        if (!voiceLangMatch)
                            throw new Error("Could not infer voiceLocale from voiceName!");
                        _voiceLocale = voiceLangMatch[0];
                    } else {
                        _voiceLocale = locale;
                    }
                },
                setFormat,
                isReady: _ => ready
            })
        });
    });

}

var tts;

async function init() {
    tts = await create_edge_TTS();
}

typeof Promise != "undefined" && init();

//-------------------------------

async function speak(chn) {
    try {
        await tts._(chn)
    } catch (e) {
        console.log('catch error:')
        console.log(e)
    }
}

//endregion
